##---------------------------------
## Exo1:
## SVM linéaire: comprendre les SVM
##---------------------------------

##---------------------------------
## Generation des donnees datalin
##---------------------------------
## sigma = 1
## mpos = 0
## mneg = 3
## xpos <- matrix(rnorm(120,mean=mpos,sd=sigma),,2)
## xneg <- matrix(rnorm(120,mean=mneg,sd=sigma),,2)
## x <- rbind(xpos,xneg)
## y <- matrix(c(rep(1,60),rep(-1,60)))
## write.table(as.data.frame(cbind(x,y)),"datalin.train")
## xpos <- matrix(rnorm(20,mean=mpos,sd=sigma),,2)
## xneg <- matrix(rnorm(20,mean=mneg,sd=sigma),,2)
## x <- rbind(xpos,xneg)
## y <- matrix(c(rep(1,10),rep(-1,10)))
## write.table(as.data.frame(cbind(x,y)),"datalin.test")

## Charger la lib
library(kernlab)

## Definir une fonction de plot
source("plotsvm.r")

## Charger les données datalin.
train = read.table("datalin.train")
test = read.table("datalin.test")

xtrainpos <- train[train[3] == 1,-3]
xtrainneg <- train[train[3] == -1,-3]
xtrain <- as.matrix(train[,-3])
ytrain <- train[,3]

xtestpos <- test[test[3] == 1,-3]
xtestneg <- test[test[3] == -1,-3]
xtest <- as.matrix(test[,-3])
ytest <- test[,3]

## Entrainer puis visualiser une SVM lineaire (vanilladot) avec C=100
svp <- ksvm(xtrain,ytrain,type="C-svc",kernel='vanilladot',C=100,scaled=c())
#plot(svp,data=xtrain)
plotsvm(svp,xtrain)

# w%*%t(xtrain[svp@SVindex,])-svp@b

## Meme chose avec C=1
svp <- ksvm(xtrain,ytrain,type="C-svc",kernel='vanilladot',C=1,scaled=c())
x11()
plotsvm(svp,xtrain)

## Afficher les points de test.
points(xtestpos, col="red",pch=16)
points(xtestneg, col="blue",pch=17)

## Utiliser svp (la svm entrainee) pour predire
## les y_i des x_i de test
predict(svp,xtest)

## Afficher les y_i reels pour comparaison
ytest

## Recuperation des donnees spam
xC = as.matrix(read.table("dataC.txt"))
yC = as.matrix(read.table("labelsC.txt"))

xpos <- xC[yC==1,1:50]
xneg <- xC[yC==0,1:50]

ntr = 150
nts = length(yC) - ntr

xtrain = rbind(xpos[1:(ntr/2),],xneg[1:(ntr/2),])
ytrain = c(rep(1,times=ntr/2),rep(0,times=ntr/2))

xtest = rbind(xpos[-(1:(ntr/2)),],xneg[-(1:(ntr/2)),])
ytest = c(rep(1,times=nrow(xpos[-(1:(ntr/2)),])),rep(0,times=nrow(xneg[-(1:(ntr/2)),])))

## Calcul de l'erreur sur les points d'entrainement et de test pour
## plusieurs valeurs de C.

errtr=c()
errts=c()
for(i in -3:2)
{
svp <- ksvm(xtrain,ytrain,type="C-svc",kernel='vanilladot',C=10^i,scaled=c())
errtr = c(errtr,error(svp))
errts = c(errts,sum(predict(svp,xtest) != ytest)/length(ytest))
}

## Affichage de l'erreur en fonction de C (train en trait plein, test
## en pointilles).

plot(-3:2,errtr,type='l',xlab='log10(C)',ylab='Classification error')
lines(-3:2,errts,type='l',lty=2)


##------------------------------------------
## Exo2:
## SVM non linéaires: comprendre les noyaux.
##------------------------------------------

##---------------------------------
## Generation des donnees datamix
##---------------------------------
## x1 = rnorm(100,mean=0,sd=2)
## x2 = rnorm(100,mean=0,sd=0.5)
## x = cbind(x1,x2)
## x1 = rnorm(100,mean=-3,sd=1)
## x2 = rnorm(100,mean=0,sd=1)
## x = rbind(x,cbind(x1,x2))
## x1 = rnorm(100,mean=3,sd=1)
## x2 = rnorm(100,mean=0,sd=1)
## x = rbind(x,cbind(x1,x2))
## x1 = rnorm(150,mean=0,sd=1)
## x2 = rnorm(150,mean=2.5,sd=1)
## x = rbind(x,cbind(x1,x2))
## x1 = rnorm(150,mean=0,sd=1)
## x2 = rnorm(150,mean=-2.5,sd=1)
## x = rbind(x,cbind(x1,x2))
## y = c(rep(1,300),rep(-1,300))
## train = cbind(x,y)
## x1 = rnorm(10,mean=0,sd=2)
## x2 = rnorm(10,mean=0,sd=0.5)
## x = cbind(x1,x2)
## x1 = rnorm(10,mean=-3,sd=1)
## x2 = rnorm(10,mean=0,sd=1)
## x = rbind(x,cbind(x1,x2))
## x1 = rnorm(10,mean=3,sd=1)
## x2 = rnorm(10,mean=0,sd=1)
## x = rbind(x,cbind(x1,x2))
## x1 = rnorm(15,mean=0,sd=1)
## x2 = rnorm(15,mean=2.5,sd=1)
## x = rbind(x,cbind(x1,x2))
## x1 = rnorm(15,mean=0,sd=1)
## x2 = rnorm(15,mean=-2.5,sd=1)
## x = rbind(x,cbind(x1,x2))
## y = c(rep(1,30),rep(-1,30))
## test = cbind(x,y)
## write.table(as.data.frame(train),"datamix.train")
## write.table(as.data.frame(test),"datamix.test")

## Charger les donnees datamix
train = read.table("datamix.train")
test = read.table("datamix.test")

xtrainpos <- train[train[3] == 1,-3]
xtrainneg <- train[train[3] == -1,-3]
xtrain <- as.matrix(train[,-3])
ytrain <- train[,3]

xtestpos <- test[test[3] == 1,-3]
xtestneg <- test[test[3] == -1,-3]
xtest <- as.matrix(test[,-3])
ytest <- test[,3]

## Afficher les donnees datamix
plot(train[,c(2,1)],pch=20,col=c("red","blue")[1+((train[,3]+1)/2)])
x11()
plot(test[,c(2,1)],pch=20,col=c("red","blue")[1+((test[,3]+1)/2)])

## Entrainer puis visualiser une SVM lineaire (vanilladot) avec C=1
svp <- ksvm(xtrain,ytrain,type="C-svc",kernel='vanilladot',C=1)
plot(svp,data=xtrain)

## Entrainer puis visualiser une SVM avec noyau rbf, sigma=1, C=1.
svp <- ksvm(xtrain,ytrain,type="C-svc",kernel='rbf',kpar=list(sigma=1),C=1)
x11()
plot(svp,data=xtrain)
